#include "lcd.h"
#include "lcd_init.h"
#include "lcdfont.h"


/******************************************************************************
      ˵ָɫ
      ݣxsta,ysta   ʼ
                xend,yend   ֹ
								color       Ҫɫ
      ֵ  
******************************************************************************/
void LCD_Fill(unsigned int xsta,unsigned int ysta,unsigned int xend,unsigned int yend,unsigned int color)
{          
	unsigned int i,j; 
	LCD_Address_Set(xsta,ysta,xend-1,yend-1);//ʾΧ
	for(i=ysta;i<yend;i++)
	{													   	 	
		for(j=xsta;j<xend;j++)
		{
			LCD_WR_DATA(color);
		}
	} 					  	    
}

/******************************************************************************
      ˵ָλû
      ݣx,y 
                color ɫ
      ֵ  
******************************************************************************/
void LCD_DrawPoint(unsigned int x,unsigned int y,unsigned int color)
{
	LCD_Address_Set(x,y,x,y);//ùλ 
	LCD_WR_DATA(color);
} 


/******************************************************************************
      ˵
      ݣx1,y1   ʼ
                x2,y2   ֹ
                color   ߵɫ
      ֵ  
******************************************************************************/
void LCD_DrawLine(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2,unsigned int color)
{
	unsigned int t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance;
	int incx,incy,uRow,uCol;
	delta_x=x2-x1; // 
	delta_y=y2-y1;
	uRow=x1;//
	uCol=y1;
	if(delta_x>0)incx=1; //õ 
	else if (delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;}
	if(delta_y>0)incy=1;
	else if (delta_y==0)incy=0;//ˮƽ 
	else {incy=-1;delta_y=-delta_x;}
	if(delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y;
	for(t=0;t<distance+1;t++)
	{
		LCD_DrawPoint(uRow,uCol,color);//
		xerr+=delta_x;
		yerr+=delta_y;
		if(xerr>distance)
		{
			xerr-=distance;
			uRow+=incx;
		}
		if(yerr>distance)
		{
			yerr-=distance;
			uCol+=incy;
		}
	}
}


/******************************************************************************
      ˵
      ݣx1,y1   ʼ
                x2,y2   ֹ
                color   εɫ
      ֵ  
******************************************************************************/
void LCD_DrawRectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2,unsigned int color)
{
	LCD_DrawLine(x1,y1,x2,y1,color);
	LCD_DrawLine(x1,y1,x1,y2,color);
	LCD_DrawLine(x1,y2,x2,y2,color);
	LCD_DrawLine(x2,y1,x2,y2,color);
}


/******************************************************************************
      ˵Բ
      ݣx0,y0   Բ
                r       뾶
                color   Բɫ
      ֵ  
******************************************************************************/
void Draw_Circle(unsigned int x0,unsigned int y0,u8 r,unsigned int color)
{
	int a,b;
	a=0;b=r;	  
	while(a<=b)
	{
		LCD_DrawPoint(x0-b,y0-a,color);             //3           
		LCD_DrawPoint(x0+b,y0-a,color);             //0           
		LCD_DrawPoint(x0-a,y0+b,color);             //1                
		LCD_DrawPoint(x0-a,y0-b,color);             //2             
		LCD_DrawPoint(x0+b,y0+a,color);             //4               
		LCD_DrawPoint(x0+a,y0-b,color);             //5
		LCD_DrawPoint(x0+a,y0+b,color);             //6 
		LCD_DrawPoint(x0-b,y0+a,color);             //7
		a++;
		if((a*a+b*b)>(r*r))//жҪĵǷԶ
		{
			b--;
		}
	}
}

/******************************************************************************
      ˵ʾִ
      ݣx,yʾ
                *s Ҫʾĺִ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ ѡ 16 24 32
                mode:  0ǵģʽ  1ģʽ
      ֵ  
******************************************************************************/
void LCD_ShowChinese(unsigned int x,unsigned int y,u8 *s,unsigned int fc,unsigned int bc,u8 sizey,u8 mode)
{
	while(*s!=0)
	{
		if(sizey==16) LCD_ShowChinese16x16(x,y,s,fc,bc,sizey,mode);
		else if(sizey==24) LCD_ShowChinese24x24(x,y,s,fc,bc,sizey,mode);
		else if(sizey==32) LCD_ShowChinese32x32(x,y,s,fc,bc,sizey,mode);
		else return;
		s+=2;
		x+=sizey;
	}
}

/******************************************************************************
      ˵ʾ16x16
      ݣx,yʾ
                *s Ҫʾĺ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
                mode:  0ǵģʽ  1ģʽ
      ֵ  
******************************************************************************/
void LCD_ShowChinese16x16(unsigned int x,unsigned int y,u8 *s,unsigned int fc,unsigned int bc,u8 sizey,u8 mode)
{
	u8 i,j;
	unsigned int k;
	unsigned int HZnum;//Ŀ
	unsigned int TypefaceNum;//һַռֽڴС
	unsigned int x0=x;
	TypefaceNum=sizey/8*sizey;//㷨ָֻֿߣָ8ı֣
	                          //ҲûʹС,ʾ׳⣡
	HZnum=sizeof(tfont16)/sizeof(typFNT_GB16);	//ͳƺĿ
	for(k=0;k<HZnum;k++) 
	{
		if ((tfont16[k].Index[0]==*(s))&&(tfont16[k].Index[1]==*(s+1)))
		{ 	
			LCD_Address_Set(x,y,x+sizey-1,y+sizey-1);
			for(i=0;i<TypefaceNum;i++)
			{
				for(j=0;j<8;j++)
				{	
					if(!mode)//ǵӷʽ
					{
						if(tfont16[k].Msk[i]&(0x01<<j))LCD_WR_DATA(fc);
						else LCD_WR_DATA(bc);
					}
					else//ӷʽ
					{
						if(tfont16[k].Msk[i]&(0x01<<j))	LCD_DrawPoint(x,y,fc);//һ
						x++;
						if((x-x0)==sizey)
						{
							x=x0;
							y++;
							break;
						}
					}
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 


/******************************************************************************
      ˵ʾ24x24
      ݣx,yʾ
                *s Ҫʾĺ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
                mode:  0ǵģʽ  1ģʽ
      ֵ  
******************************************************************************/
void LCD_ShowChinese24x24(unsigned int x,unsigned int y,u8 *s,unsigned int fc,unsigned int bc,u8 sizey,u8 mode)
{
	u8 i,j;
	unsigned int k;
	unsigned int HZnum;//Ŀ
	unsigned int TypefaceNum;//һַռֽڴС
	unsigned int x0=x;
	TypefaceNum=sizey/8*sizey;//㷨ָֻֿߣָ8ı֣
	                          //ҲûʹС,ʾ׳⣡
	HZnum=sizeof(tfont24)/sizeof(typFNT_GB24);	//ͳƺĿ
	for(k=0;k<HZnum;k++) 
	{
		if ((tfont24[k].Index[0]==*(s))&&(tfont24[k].Index[1]==*(s+1)))
		{ 	
			LCD_Address_Set(x,y,x+sizey-1,y+sizey-1);
			for(i=0;i<TypefaceNum;i++)
			{
				for(j=0;j<8;j++)
				{	
					if(!mode)//ǵӷʽ
					{
						if(tfont24[k].Msk[i]&(0x01<<j))LCD_WR_DATA(fc);
						else LCD_WR_DATA(bc);
					}
					else//ӷʽ
					{
						if(tfont24[k].Msk[i]&(0x01<<j))	LCD_DrawPoint(x,y,fc);//һ
						x++;
						if((x-x0)==sizey)
						{
							x=x0;
							y++;
							break;
						}
					}
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 

/******************************************************************************
      ˵ʾ32x32
      ݣx,yʾ
                *s Ҫʾĺ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
                mode:  0ǵģʽ  1ģʽ
      ֵ  
******************************************************************************/
void LCD_ShowChinese32x32(unsigned int x,unsigned int y,u8 *s,unsigned int fc,unsigned int bc,u8 sizey,u8 mode)
{
	u8 i,j;
	unsigned int k;
	unsigned int HZnum;//Ŀ
	unsigned int TypefaceNum;//һַռֽڴС
	unsigned int x0=x;
	TypefaceNum=sizey/8*sizey;//㷨ָֻֿߣָ8ı֣
	                          //ҲûʹС,ʾ׳⣡
	HZnum=sizeof(tfont32)/sizeof(typFNT_GB32);	//ͳƺĿ
	for(k=0;k<HZnum;k++) 
	{
		if ((tfont32[k].Index[0]==*(s))&&(tfont32[k].Index[1]==*(s+1)))
		{ 	
			LCD_Address_Set(x,y,x+sizey-1,y+sizey-1);
			for(i=0;i<TypefaceNum;i++)
			{
				for(j=0;j<8;j++)
				{	
					if(!mode)//ǵӷʽ
					{
						if(tfont32[k].Msk[i]&(0x01<<j))LCD_WR_DATA(fc);
						else LCD_WR_DATA(bc);
					}
					else//ӷʽ
					{
						if(tfont32[k].Msk[i]&(0x01<<j))	LCD_DrawPoint(x,y,fc);//һ
						x++;
						if((x-x0)==sizey)
						{
							x=x0;
							y++;
							break;
						}
					}
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
}


/******************************************************************************
      ˵ʾַ
      ݣx,yʾ
                num Ҫʾַ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
                mode:  0ǵģʽ  1ģʽ
      ֵ  
******************************************************************************/
void LCD_ShowChar(unsigned int x,unsigned int y,u8 num,unsigned int fc,unsigned int bc,u8 sizey,u8 mode)
{
	u8 temp,sizex,t;
	unsigned int i,TypefaceNum;//һַռֽڴС
	unsigned int x0=x;
	sizex=sizey/2;
	TypefaceNum=sizex/8*sizey;
	num=num-' ';    //õƫƺֵ
	LCD_Address_Set(x,y,x+sizex-1,y+sizey-1);  //ùλ 
	for(i=0;i<TypefaceNum;i++)
	{ 
		if(sizey==16)temp=ascii_1608[num][i];		       //8x16
		else if(sizey==32)temp=ascii_3216[num][i];		 //16x32
		else return;
		for(t=0;t<8;t++)
		{
			if(!mode)//ǵģʽ
			{
				if(temp&(0x01<<t))LCD_WR_DATA(fc);
				else LCD_WR_DATA(bc);
			}
			else//ģʽ
			{
				if(temp&(0x01<<t))LCD_DrawPoint(x,y,fc);//һ
				x++;
				if((x-x0)==sizex)
				{
					x=x0;
					y++;
					break;
				}
			}
		}
	}   	 	  
}


/******************************************************************************
      ˵ʾַ
      ݣx,yʾ
                *p Ҫʾַ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
                mode:  0ǵģʽ  1ģʽ
      ֵ  
******************************************************************************/
void LCD_ShowString(unsigned int x,unsigned int y,const u8 *p,unsigned int fc,unsigned int bc,u8 sizey,u8 mode)
{         
	while(*p!='\0')
	{       
		LCD_ShowChar(x,y,*p,fc,bc,sizey,mode);
		x+=sizey/2;
		p++;
	}  
}


/******************************************************************************
      ˵ʾ
      ݣmnָ
      ֵ  
******************************************************************************/
u32 mypow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;
	return result;
}


/******************************************************************************
      ˵ʾ
      ݣx,yʾ
                num Ҫʾ
                len Ҫʾλ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
      ֵ  
******************************************************************************/
void LCD_ShowIntNum(unsigned int x,unsigned int y,unsigned int num,u8 len,unsigned int fc,unsigned int bc,u8 sizey)
{         	
	u8 t,temp;
	u8 enshow=0;
	u8 sizex=sizey/2;
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+t*sizex,y,' ',fc,bc,sizey,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+t*sizex,y,temp+48,fc,bc,sizey,0);
	}
} 


/******************************************************************************
      ˵ʾλС
      ݣx,yʾ
                num ҪʾС
                len Ҫʾλ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
      ֵ  
******************************************************************************/
void LCD_ShowFloatNum1(unsigned int x,unsigned int y,float num,u8 len,unsigned int fc,unsigned int bc,u8 sizey)
{         	
	u8 t,temp,sizex;
	unsigned int num1;
	sizex=sizey/2;
	num1=num*100;
	for(t=0;t<len;t++)
	{
		temp=(num1/mypow(10,len-t-1))%10;
		if(t==(len-2))
		{
			LCD_ShowChar(x+(len-2)*sizex,y,'.',fc,bc,sizey,0);
			t++;
			len+=1;
		}
	 	LCD_ShowChar(x+t*sizex,y,temp+48,fc,bc,sizey,0);
	}
}


/******************************************************************************
      ˵ʾͼƬ
      ݣx,y
                length ͼƬ
                width  ͼƬ
                pic[]  ͼƬ    
      ֵ  
******************************************************************************/
void LCD_ShowPicture(unsigned int x,unsigned int y,unsigned int length,unsigned int width,const u8 pic[])
{
	unsigned int i,j,k=0;
	LCD_Address_Set(x,y,x+length-1,y+width-1);
	for(i=0;i<length;i++)
	{
		for(j=0;j<width;j++)
		{
			LCD_WR_DATA8(pic[k*2]);
			LCD_WR_DATA8(pic[k*2+1]);
			k++;
		}
	}			
}


