#ifndef __USB_REQ_CLASS_H__
#define __USB_REQ_CLASS_H__

#define GET_REPORT              0x01
#define GET_IDLE                0x02
#define GET_PROTOCOL            0x03
#define SET_REPORT              0x09
#define SET_IDLE                0x0A
#define SET_PROTOCOL            0x0B

#define DESC_HIDREPORT          0x22


//˴ʹTiny USBִ
#define TU_BIT(n)                     ((unsigned char)1 << (n))
    
#define KEYBOARD_MODIFIER_NONE        0
#define KEYBOARD_MODIFIER_LEFTCTRL    TU_BIT(0) ///< Left Control
#define KEYBOARD_MODIFIER_LEFTSHIFT   TU_BIT(1) ///< Left Shift
#define KEYBOARD_MODIFIER_LEFTALT     TU_BIT(2) ///< Left Alt
#define KEYBOARD_MODIFIER_LEFTGUI     TU_BIT(3) ///< Left Window
#define KEYBOARD_MODIFIER_RIGHTCTRL   TU_BIT(4) ///< Right Control
#define KEYBOARD_MODIFIER_RIGHTSHIFT  TU_BIT(5) ///< Right Shift
#define KEYBOARD_MODIFIER_RIGHTALT    TU_BIT(6) ///< Right Alt
#define KEYBOARD_MODIFIER_RIGHTGUI    TU_BIT(7)  ///< Right Window


void usb_req_class();

void usb_class_in(BYTE modifier,BYTE keycode[6]);
    
void usb_class_out();

void usb_get_report();
void usb_set_report();
void usb_get_idle();
void usb_set_idle();
void usb_get_protocol();
void usb_set_protocol();

void scan_key();

extern BYTE bHidIdle;

#endif
